<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <link rel="stylesheet" href="style.css">
</head>

<body>
<div class="carousel">
    <button class="arrow arrow__left" id="left-arrow">⇦</button>
    <div class="gallery" id="gallery">
        <ul id="gallery-ul">
            <li><img src="https://js.cx/carousel/1.png"></li>
            <li><img src="https://js.cx/carousel/2.png"></li>
            <li><img src="https://js.cx/carousel/3.png"></li>
            <li><img src="https://js.cx/carousel/4.png"></li>
            <li><img src="https://js.cx/carousel/5.png"></li>
            <li><img src="https://js.cx/carousel/6.png"></li>
            <li><img src="https://js.cx/carousel/7.png"></li>
            <li><img src="https://js.cx/carousel/8.png"></li>
            <li><img src="https://js.cx/carousel/9.png"></li>
            <li><img src="https://js.cx/carousel/10.png"></li>
        </ul>
    </div>
    <button class="arrow arrow__right" id="right-arrow">⇨</button>
</div>


<script>
    // этот код помечает картинки цифрами, для удобства разработки
    // его можно убрать, если не нужен
    var lis = document.getElementsByTagName('li');
    for (var i = 0; i < lis.length; i++) {
        lis[i].style.position = 'relative';
        var span = document.createElement('span');
        span.style.cssText = 'position:absolute;left:0;top:0';
        span.innerHTML = i + 1;
        lis[i].appendChild(span);
    }
</script>

<script>
    const scrollWidth = 3;
    let scrollMargin = 0;
    let scrollPosition = 0;
    let scrollStep = 130;
    let gallery = document.getElementById("gallery-ul");
    let imagesCount = gallery.children.length;

    let leftArrow = document.getElementById("left-arrow");
    let rightArrow = document.getElementById("right-arrow");
    leftArrow.addEventListener("click", scrollLeft);
    rightArrow.addEventListener("click", scrollRight);

    function scrollLeft() {
        let steps = Math.min(scrollWidth, scrollPosition);
        scrollPosition -= steps;
        scrollMargin += scrollStep * steps;
        gallery.style.marginLeft = scrollMargin + "px";
    }

    function scrollRight() {
        let steps = Math.min(scrollWidth, imagesCount - scrollPosition - scrollWidth);
        scrollPosition += steps;
        scrollMargin -= scrollStep * steps;
        gallery.style.marginLeft = scrollMargin + "px";
    }
</script>
</body>

</html>